/* ***** BEGIN LICENSE BLOCK *****
 *    Copyright 2003 Michel Jacobson jacobson@idf.ext.jussieu.fr
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * ***** END LICENSE BLOCK ***** */
package fr.yanntool.util;
/*-----------------------------------------------------------------------*/
import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;

import javax.swing.*;
import java.net.URL;
import java.net.MalformedURLException;
import javax.swing.text.*;
import javax.swing.event.*;

import java.beans.*;
import javax.swing.border.*;
import javax.swing.plaf.metal.*;
/*-----------------------------------------------------------------------*/
public class Sample extends JFrame {

	static Sample 			             win;
	private ConsoleInternalFrame         stdout;
	private ConsoleInternalFrame         stderr;

	public static void main(String [] arg) {
		win = new Sample("Test Console");
		win.show();
	}

	public Sample(String titre) {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		String listMenu = new String("Fichier");
		Hashtable ListMenuItems = new Hashtable();
		ListMenuItems.put("Fichier",    "stdout/stderr/-/Quitter");

		setTitle(titre);
		setBackground(Color.white);
      	getContentPane().setLayout(new BorderLayout());

		JMenuBar mb = createMenubar(listMenu, ListMenuItems);
		JDesktopPane desktop = new JDesktopPane();
		setJMenuBar(mb);
		getContentPane().add(desktop);
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		setSize(dim.width-20, dim.height-60);
		dim = getSize();

		//console pour rediriger sortie standard
		//stdout = new ConsoleFrame("stdout", new Rectangle(0, (dim.height * 20)/100, dim.width-6, dim.height-((dim.height * 20)/100)-70), true, false);
		stdout = new ConsoleInternalFrame("stdout", new Rectangle(0, (dim.height * 20)/100, dim.width-6, dim.height-((dim.height * 20)/100)-70), true, false);
		desktop.add(stdout);
		stdout.activate(true);
		usage();

		//console pour rediriger sortie erreur
		stderr = new ConsoleInternalFrame("stderr", new Rectangle(0, 0, dim.width-6, ((dim.height * 20)/100)), false, true);
		desktop.add(stderr);
		stderr.activate(true);
		System.err.println("console stderr");

		final JTextField jtf = new JTextField(50);
		jtf.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if (e.getActionCommand().equals("?")) {
					usage();
				} else if (e.getActionCommand().equals("q")) {
					quit();
				} else if (e.getActionCommand().equals("c")) {
					stdout.clear();
					stderr.clear();
				} else if (e.getActionCommand().equals("err")) {
					System.err.println("Message envoy sur stderr");
				} else {
					System.out.println(e.getActionCommand());
				}
				jtf.setText("");
			}

		});
		getContentPane().add("North", jtf);
	}
	private boolean quit() {
		dispose();
		System.exit(0);
		return true;
	}
	private void usage() {
		System.out.println("stdout:");
		System.out.println("q:\tQuitter");
		System.out.println("c:\tEffacer");
		System.out.println("?:\tAide");
		System.out.println("err:\tProduit un message d'erreur");
	}
	private JMenuBar createMenubar(String liste, Hashtable hash) {
		JMenuItem mi;
		JMenuBar mb = new JMenuBar();

		StringTokenizer menuKeys = new StringTokenizer(liste, "/");
		while (menuKeys.hasMoreTokens()) {
			String name = menuKeys.nextToken();
			JMenu m = createMenu(name, hash);
			if (m != null) {
				mb.add(m);
			}
		}
		return mb;
	}
	private JMenu createMenu(String key, Hashtable hash) {
		JMenu menu = new JMenu(key);
		String s = (String)hash.get(key);
		StringTokenizer menuItems = new StringTokenizer(s, "/");
		while (menuItems.hasMoreTokens()) {
			String name = menuItems.nextToken();
			if (name.equals("-")) {
				menu.addSeparator();
			} else if (name.equals("stdout")) {
				final JCheckBoxMenuItem mi = new JCheckBoxMenuItem(name, true);
				mi.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						stdout.activate(mi.getState());
					}
				});
				menu.add(mi);
			} else if (name.equals("stderr")) {
				final JCheckBoxMenuItem mi = new JCheckBoxMenuItem(name, true);
				mi.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						stderr.activate(mi.getState());
					}
				});
				menu.add(mi);
			} else if (name.equals("Quitter")) {
				final JMenuItem mi = createMenuItem(name);
				mi.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						quit();
					}
				});
				menu.add(mi);
			}
		}
		return menu;
	}
	private JMenuItem createMenuItem(String cmd) {
		JMenuItem mi = new JMenuItem(cmd);
		return mi;
	}
};